<!--suppress ALL -->

<!--eslint-disable -->
<template>
    <div>
        <div uk-height-match="row: false" class="uk-container uk-margin-medium-bottom">
            <div class="uk-flex">
                <div class="uk-width-2-3 uk-card uk-card-primary uk-card-body">
                    <div class="uk-container">
                        <form>
                            <fieldset class="uk-fieldset">
                                <legend class="uk-legend">Lab 8. Eigenvalues and vectors</legend>
                                <div class="uk-margin">
                                    <label class="uk-form-label" for="rng">Size: {{size}}</label>
                                    <input id="rng" v-model="size" class="uk-range" type="range" value="3" min="1"
                                           max="6" step="1">
                                </div>
                                <div class="uk-margin">
                                    <form class="uk-flex">
                                        <div class="uk-width-5-6 uk-grid uk-grid-margin-small" uk-grid>
                                            <div id="matrix" v-for="(items,index) in matr"
                                                 v-bind:class="'uk-width-1-' + size">
                                                <input v-for="(item,index1) in items"
                                                       v-bind:tabindex="index1*size+index+10"
                                                       v-on:input="buildJaxMatrixFormula" v-model="matr[index1][index]"
                                                       class="uk-input uk-margin-small" type="number" placeholder="0">
                                            </div>
                                        </div>
                                        <div id="vector" class="uk-width-1-6 uk-margin-medium-left">
                                            <input v-for="(v,index) in vector" v-model="vector[index]"
                                                   v-on:input="buildJaxVectorFormula"
                                                   v-bind:tabindex="Math.pow(size,2)+11+index"
                                                   class="uk-input uk-margin-small" type="number" placeholder="0">
                                        </div>
                                    </form>

                                </div>
                                <a class="uk-button uk-button-default" v-on:click="rndMatrix()">Randomize matrix</a>
                                <a class="uk-button uk-button-default" v-on:click="rndVector()">Randomize vector</a>
                                <a class="uk-button uk-button-default" v-on:click="send()">Send</a>
                            </fieldset>
                        </form>
                    </div>
                </div>


                <div class="uk-width-1-3 uk-container uk-card uk-card-default uk-card-body">
                    <center><h3 class="uk-card-title">Data</h3></center>
                    <div class="">
                        <h3>Matrix size: {{size}}</h3>

                        <div>
                            Matrix:
                            <span v-katex="{ expression: matrixFormula.toString() }"></span>
                            <!--<katex-element expression="'\\frac{a_i}{1+x}'"/>-->
                            <!--<vue-katex :expression="matrixFormula"></vue-katex>-->
                        </div>
                        <div>
                            Vector:
                            <span v-katex="{ expression: vectorFormula.toString() }"></span>
                        </div>
                    </div>
                    <div uk-height-viewport style="width: 100%" v-bind:class="{ 'uk-hidden': inputLoader}"
                         class="uk-overlay uk-position-fixed uk-overlay-default uk-position-center">
                        <div class="uk-position-absolute uk-position-center" uk-spinner="ratio: 3"></div>
                    </div>
                </div>
            </div>
        </div>
        <div v-if="resultVFormula.length !== 0" class="uk-margin-medium-top uk-margin-small-bottom uk-card uk-card-default uk-card-body">
            <h3 class="uk-card-title">Result</h3>
            <div v-katex="{ expression: resultVFormula.toString() }"></div>
        </div>
        <div uk-height-viewport style="width: 100%" v-bind:class="{ 'uk-hidden': loader }"
             class="uk-overlay uk-position-fixed uk-overlay-default uk-position-center">
            <div class="uk-position-absolute uk-position-center" uk-spinner="ratio: 3"></div>
        </div>
    </div>
</template>

<script>
    /* eslint-disable */
    import axios from 'axios';
    import cors from 'cors';
    const RECAPTCHA_TOKEN = `6LfH7pcUAAAAAFQRu7gxejZzC57TYZY0qOwcDJmJ`;
    // import VueRecaptcha from 'vue-recaptcha';
    export const HTTP = axios.create({
        baseURL: 'https://cw.enderbot.ru/api',
        timeout: 10000,
        withCredentials: false,
        headers: {
            // 'Access-Control-Allow-Origin': '*',
            'Content-Type': 'application/json'
        }
    });

    export default {
        components: {
            // 'vue-mathjax': VueMathjax,
        },
        name: 'lab8',
        props: {
            msg: String,
        },
        created: function () {
            this.buildJaxMatrixFormula();
            this.buildJaxVectorFormula();
        },
        data: function () {
            return {
                size: 1,
                matr: [[0]],
                vector: [0],
                respData: {
                    vector: [[]],
                },
                loader: true,
                inputLoader: true,
                matrixTemplate: '\\begin{pmatrix}\n %MATRIX% \\end{pmatrix}\n',
                matrixFormula: '',
                vectorFormula: '',
                resultVFormula: '',
            }
        },
        watch: {
            size: function (value, oldValue) {
                if (value < oldValue) {
                    for (let i = 0; i < oldValue; i++) {
                        for (let j = value; j < oldValue; j++) {
                            this.matr[i].pop();
                        }
                    }
                    for (let i = value; i < oldValue; i++) {
                        this.matr.pop();
                        this.vector.pop();
                    }
                } else {
                    for (let i = oldValue; i < value; i++) {
                        this.matr.push([]);
                        for (let j = 0; j < value; j++) {
                            this.matr[i].push(0);
                        }
                        this.vector.push(0);
                    }
                    for (let i = 0; i < oldValue; i++) {
                        for (let j = oldValue; j < value; j++) {
                            this.matr[i].push(0);
                        }
                    }
                }
                this.buildJaxMatrixFormula();
                this.buildJaxVectorFormula();

            }
        },
        methods: {
            recaptchaToken: async function() {
                    return new Promise((resolve) => {
                        // eslint-disable-next-line no-undef
                        // noinspection JSUnresolvedVariable
                        grecaptcha.ready(async () => {
                            // eslint-disable-next-line no-undef
                            // noinspection ES6ModulesDependencies
                            // noinspection JSUnresolvedVariable
                            const token = await grecaptcha.execute(RECAPTCHA_TOKEN);
                            resolve(token);
                        });
                    });
            },
            buildResult: function (obj) {
                let size = obj.vectors.length;
                this.resultVFormula = '';
                for (let j = 0; j < size; j++){
                    let vector = '';
                    for (let i = 0; i < obj.vectors[j].length; i++) {
                        vector += obj.vectors[j][i] + ' ';
                        vector = vector.slice(0, -1);
                        vector += "\\\\";
                    }
                    this.resultVFormula += this.matrixTemplate.replace("%MATRIX%", vector)
                }
                // this.resultVFormula = this.matrixTemplate.replace("%MATRIX%", matrixStr)
            },
            buildJaxMatrixFormula: function () {
                let matrix = '';
                for (let i = 0; i < this.size; i++) {
                    for (let j = 0; j < this.size; j++) {
                        matrix += this.matr[i][j] + '&';
                    }
                    matrix = matrix.slice(0, -1);
                    matrix += "\\\\";
                }
                this.matrixFormula = this.matrixTemplate.replace("%MATRIX%", matrix)
            },
            buildJaxVectorFormula: function () {
                let vector = '';
                for (let i = 0; i < this.size; i++) {
                    vector += this.vector[i] + ' ';
                    vector = vector.slice(0, -1);
                    vector += "\\\\";
                }
                this.vectorFormula = this.matrixTemplate.replace("%MATRIX%", vector)
            },

            rndMatrix: function () {
                console.log('Matrix randomize');
                this.matr = [];
                for (let i = 0; i < this.size; i++) {
                    this.matr.push([]);
                    for (let j = 0; j < this.size; j++) {
                        this.matr[i][j] = Math.floor(Math.random() * 10);
                    }
                }
                this.buildJaxMatrixFormula();
            },
            rndVector: function () {
                console.log('Vector randomize');
                this.vector = [];
                for (let i = 0; i < this.size; i++) {
                    for (let j = 0; j < this.size; j++) {
                        this.vector[i] = Math.floor(Math.random() * 10);
                    }
                }
                this.buildJaxVectorFormula();
            },

            send: async function () {

                this.loader = false;
                const token = await this.recaptchaToken();
                // const token = "tejghahjg@124asd";
                let obj = {
                    size: null,
                    matrix: this.matr,
                    vector: this.vector,
                };
                obj.size = parseFloat(this.size);
                let obj2 = {
                    gtoken: token,
                    data: obj
                };
                let axiosPromise = HTTP.post('/lab8/', obj2);
                axiosPromise.then((response) => {
                    this.loader = true;
                    console.log('response');
                    console.log(response);
                    this.buildResult(response.data);
                }).catch((error) => {
                    this.loader = true;
                    console.log('error');
                    console.log(JSON.stringify(obj2));
                    console.log(error);
                });
                this.loader = true;
            }
        }
    }
</script>
<style lang="less">
    /*@import "../../node_modules/uikit/src/less/uikit.less";*/
</style>
